library template;
{  TEMPLATE.DPR
   Przykadowa wtyczka dla programu Konnekt...
   Idealny sposb eby zacz pisa co swojego ...

   (c)2002 hao | Stamina
   (c)2005 Winthux
   http://www.konnekt.info
}

uses
  Plug in '..\..\api\plug.pas',
  PlugDefs in '..\..\api\plugdefs.pas',
  ui in '..\..\api\ui.pas';

{$R *.res}
const
  version: PChar = '0.0.0.0';
  name: PChar = 'Template';
  sig: PChar = 'tpl';

//---------------------------------------------------------------------------
{ Wszystkie ponisze funkcje nie s wymagane (z wyjtekim IMEssageProc)...
   ale z nimi wszystko wyglda czytelniej :)
}
function Init(): Integer;
begin
    {  Tutaj inicjalizujemy wtyczk,
       zgaszamy dania pocze itp. }
  Result := 1;
end;

function DeInit(): Integer;
begin
  {  Najlepsze miejsce eby posprzta...
  }
  Result := 1;
end;

function IStart(): Integer;
begin
  { Tutaj wtyczk uruchamiamy }
  Result := 1;
end;

function IEnd(): Integer;
begin
  { Tutaj wtyczk wyczamy }
  Result := 1;
end;

function ISetCols(): Integer;
begin
  {  Tutaj rejestrujemy kolumny w plikach ustawie.
     Pamitaj o tym e identyfikatory MUSZ by UNIKATOWE! }
  Result := 1;
end;

function IPrepare(): Integer;
begin
  { Tutaj rejestrujemy sie w interfejsie }
  Result := 1;
end;

function ActionCfgProc(const anBase: sUIActionNotify_basePtr): Integer;
{  Tutaj obsugujemy akcje dla okna konfiguracji
   Sytuacja taka sama jak przy ActionProc  }
var
  an: sUIActionNotify_2paramsPtr;
begin
  an := sUIActionNotify_2paramsPtr(anBase);

  case (anBase.act.id and not IMIB_CFG) of
    IMIB_CFG:;     // cos musi byc, nie da sie tak jak w c/c++ pusty switch
  end;

  Result := 0;
end;

function ActionProc(const anBase: sUIActionNotify_basePtr): Integer;
{ Tutaj obsugujemy akcje }
  {  Ponisza linijka suy TYLKO waszej wygodzie!
     Wikszo (o ile nie wszystkie) powiadomie przesyana jest jako sUIActionNotify_2params,
     korzystamy wtedy z obiektu an, w przeciwnym razie z anBase, lub castujemy do spodziewanego typu.
  }
var
  an: sUIActionNotify_2paramsPtr;
begin
  an := sUIActionNotify_2paramsPtr(anBase);

  if ((anBase.act.id and IMIB_) = IMIB_CFG) then
    Result := ActionCfgProc(anBase)
  else
    begin
      case (anBase.act.id) of
        IMIB_:;       // cos musi byc w case of, inaczej blad kompilator wywala
      end;
      Result := 0;
    end;
end;

function IMessageProc(const msgBase: sIMessage_basePtr): Integer; stdcall;
 { Tam gdzie nie uywasz parametrw, najbezpieczniej korzysta z msgBase }
    {Wikszo (o ile nie wszystkie) wiadomoci przesyana jest jako sIMessage_2params,
     korzystamy wtedy z obiektu msg, w przeciwnym razie z msgBase, lub castujemy do spodziewanego typu.
    }
var
  msg: sIMessage_2paramsPtr;
  ret: Integer;

begin
  msg := sIMessage_2paramsPtr(msgBase);
  ret := -1;

  case msgBase.id of
    { Wiadomoci na ktre TRZEBA odpowiedzie }
    IM_PLUG_NET: ret := 0;  // Zwracamy warto NET, ktra MUSI by rna od 0!
    IM_PLUG_TYPE: ret := 0;   // Zwracamy jakiego typu jest nasza wtyczka (ktre wiadomoci bdziemy obsugiwa)
    IM_PLUG_VERSION: ret := Integer(version); // Wersja wtyczki tekstowo major.minor.release.build ..., lub 0 jeeli wersja zapisana jest w zasobach DLLa
    IM_PLUG_SDKVERSION: ret := KONNEKT_SDK_V; // Ta linijka jest wymagana!
    IM_PLUG_SIG: ret :=  Integer(sig); // Sygnaturka wtyczki (krtka, kilkuliterowa nazwa)
    IM_PLUG_NAME: ret := Integer(name); // Pena nazwa wtyczki (ale najlepiej nie za duga!)
    IM_PLUG_NETNAME: ret := 0; // Nazwa obsugiwanej sieci (o ile jak sie obsuguje)
    IM_PLUG_INIT:
      begin
        Plug_Init(msg.p1, msg.p2);
        ret := Init();
      end;
    IM_PLUG_DEINIT:
      begin
        Plug_Deinit(msg.p1, msg.p2);
        ret := DeInit();
      end;

    IM_SETCOLS: ret:= ISetCols();

    IM_UI_PREPARE: ret := IPrepare();
    IM_START: ret := IStart();
    IM_END: ret := IEnd();

    IM_UIACTION: ret := ActionProc(sUIActionNotify_basePtr(msg.p1));
  end;

  { Tutaj obsugujemy wszystkie pozostae komunikaty }
  { Z kadego komunikatu trzeba zwraca warto wiksz od 0. W przeciwnym razie,
    zostanie ustawiony bd i komunikat zostanie uznany za nie obsuony }


  if Assigned(Ctrl) and (ret < 0) then
  begin
    Ctrl.setError(IMERROR_NORESULT);
    ret := 0;
  end;

  Result := ret;
end;

exports
  IMessageProc;

begin
end.
