library ActCfg;
{  ActCfg.DPR
   Przykadowa wtyczka dla programu Konnekt...
   Idealny sposb eby zacz pisa co swojego ...

   Przykady:
    -> Wykorzystania tablic ustawie
    -> Wykorzystania okien dialogowych
    -> Obsugi akcji
    -> Obsugi konfiguracji
    -> Obsugi akcji kontaktw
    -> Prostego adowania ikonek

   Aby zobaczy ikonk, trzeba do skompilowanego projektu doda Resources i do nich
   ikonk (16px x 16px) o identyfikatorze rwnym 100.

   (c)2002 hao | Stamina
   (c)2005 Winthux
   http://www.konnekt.info
}

uses
  Windows,
  SysUtils,
  Plug in '..\..\api\Plug.pas',
  PlugDefs in '..\..\api\PlugDefs.pas',
  ui in '..\..\api\ui.pas',
  PlugFunc in '..\..\api\PlugFunc.pas';

{$R *.res}

const
  version: PChar = '0.0.0.0';
  name: PChar = 'Template';
  sig: PChar = 'Ex2';
  core_v: PChar = 'W98';

  CFG_EXAMPLE_VALUE = 5000;  // Pozycja w tablicy konfiguracji
  CFG_EXAMPLE_DEFAULT_VALUE = 'Warto domylna!'; // Wartosc domyslna
  IMIG_CFG_EXAMPLE = 5000;  // Grupa w akcji w konfiguracji
  IMIA_CFG_EXAMPLE_BUTTON = 5001;  // Akcja w konfiguracji
  IMIG_EXAMPLE = 5010;  // Grupa na gwnym toolbarze
  IMIA_EXAMPLE_BUTTON = 5011;  // Akcja w menu na gwnym toolbarze
  IMIA_CNT_EXAMPLE = 5020;  // Akcja dla kontaktw
  IM_EX_TEST = 5000; // Identyfikator wiadomoci do wykorzystania przez inne wtyczki...
  IDI_EXAMPLE = 5000;            // Identyfikator ikonki
  IDI_POINT = 3; // Ta ikonka jest ju zarejestrowana przez UI. Uwierzcie na sowo :)

  NET_EXAMPLE = 5; // Wartosc net tej wtyczki


//---------------------------------------------------------------------------
{ Wszystkie ponisze funkcje nie s wymagane (z wyjtekim IMEssageProc)...
   ale z nimi wszystko wyglda czytelniej :)
}
function Init(): Integer;
begin
    {  Do inicjalizowania nie mamy nic...  }
  Result := 1;
end;

function DeInit(): Integer;
begin
  {  Do usuwania rwnie...
  }
  Result := 1;
end;

function ISetCols(): Integer;
begin
   { Rejestrujemy kolumn w konfiguracji (DTCFG).
     Niech bdzie to warto tekstowa - czyli DT_CT_STR
         Dla porzdku nadamy jej te nazw...
     }
  SetColumn(DTCFG, CFG_EXAMPLE_VALUE, DT_CT_STR, CFG_EXAMPLE_DEFAULT_VALUE , 'Example/actcfg/exampleValue');
  Result := 1;
end;

function IPrepare(): Integer;
begin
  {  Tutaj rejestrujemy sie w interfejsie.
     Do zarejestrowania mamy 5 akcji i jedn ikonk.
     Bdziemy korzysta z gotowych funkcji z plug_func.h}
  {  W tej chwili SDK dysponuje tylko jedn wiadomoci do rejestrowania ikonek.
     W nastpnej edycji SDK powinny pojawi si wiksze moliwoci... }
        IconRegister(IML_16, IDI_EXAMPLE, Ctrl.hDll(), 100, 1);

  { Rejestrujemy akcje ktre bd widoczne na toolbarze w oknie gwnym.

     Najpierw rejestrujemy grup, ktr dodajemy do grupy IMIG_MAINTB.
     W ten sposb tworzymy now ikonk na toolbarze.
     Wstawiamy j na drug pozycj od lewej.
  }
   UIGroupInsert(IMIG_MAINTB  // Grupa - matka
       , IMIG_EXAMPLE        // ID nowej grupy
       , 1                   // Pozycja do wstawienia. 0 - pocztek -1 - koniec
       , 0                   // Status akcji. Powinnimy poda ACTS_GROUP, ale UIGroupInsert robi to ju za nas...
       , 'Przykad'          // Tre akcji. W tym wypadku zawarto tooltipa
       , IDI_POINT         // jako P1 w menusach podajemy ID ikonki
       ); // Reszt parametrw moemy sobie darowa. Wszystkie i tak s rwne 0!
      { Dodajemy akcj }
  UIActionAdd(IMIG_EXAMPLE // Wstawiamy do utworzonej ju grupy
      , IMIA_EXAMPLE_BUTTON
      , 0
      , 'Wcinij mnie!'
      , IDI_EXAMPLE // Identyfikator naszej ikonki z zasobw wtyczki
      );
  { Dodajemy akcj do menu kontaktw. Dodatkowo zrobimy tak, aby pojawiaa sie tylko przy
     kontaktach bez sieci!}
  UIActionAdd(IMIG_CNT // Menu kontaktw
      , IMIA_CNT_EXAMPLE // ID akcji
      , 0 //ACTR_INIT nie dziaa-ulego cos zmianie  // Rzdamy powiadomienia o utworzeniu pozycji w menu
      , 'Jestem spoza sieci!'
      , IDI_EXAMPLE
      );
  { wietnie, dodajmy teraz akcje do konfiguracji }
  { Najpierw tworzymy grup }
  UIGroupAdd(IMIG_CFG  // Grupa - matka
       , IMIG_CFG_EXAMPLE        // ID nowej grupy
       , 0                   // Status akcji. Powinnimy poda ACTS_GROUP, ale UIGroupInsert robi to ju za nas...
       , 'Przykad!'          // Tre akcji. W tym wypadku zawarto tooltipa
       , IDI_POINT         // jako P1 w grupach konfiguracji podajemy ID ikonki
       ); // Reszt parametrw moemy sobie darowa. Wszystkie i tak s rwne 0!
  {  Teraz robi si ciut ciekawiej. Najpierw dodajmy krtki opis. Nie potrzebujemy do tego
     identyfikatora bo i tak nic z nim nie bdziemy robi.
     Funkcja UIActionCfgAdd przydaje si TYLKO gdy chcemy przesun kontrolk wzgldem osi x lub y.
     Spokojnie mona uyc UIActionAdd ...
     }
  {  Dobr 'manier' w konfiguracji jest grupowanie kontrolek... a wic }
  UIActionAdd(IMIG_CFG_EXAMPLE , 0 , ACTT_GROUP , 'Przykad z actcfg.cpp');
    UIActionCfgAdd(IMIG_CFG_EXAMPLE  // Grupa - matka
        , 0
        , ACTT_INFO           // Status akcji. Podajemy ACTT_INFO jako typ wstawianej kontrolki...
        , 'Wpisz poniej dowolny tekst.'#13#13'Jeeli wpiszesz "aa" stanie si co dziwnego!'          // Tre informacji.
        , IDI_POINT         // jako P1 w menusach podajemy ID ikonki
        ,0,0  // Przesunicie wzgldem x i y zostawiamy w spokoju...
        ,100  // Szeroko. ACTT_INFO jest rozcigany na ca szeroko. Nie ma znaczenia co tutaj wpiszemy
        ,40   // Wysoko. Niech nasze info ma 40 pixeli wysokoci...
        ); // Reszt parametrw moemy sobie darowa. Wszystkie i tak s rwne 0!
   { Teraz dodamy kontrolk przy pomocy ktrej moemy edytowa nasz kolumn CFG_EXAMPLE_VALUE.
       UI automatycznie zajmuje si konwersj typw i adowaniem/zapisywaniem. My za to
       bdziemy sprawdza, czy to co jest wpisywane, wpisywane jest poprawnie... }
    UIActionCfgAdd(IMIG_CFG_EXAMPLE  // Grupa - matka
        , IMIB_CFG   { Ustawiajc identyfikator w ten sposb mamy pewno, e faktycznym identyfikatorem akcji
                        bdzie IMIB_CFG or P1, gdzie P1 zaraz stanie si identyfikatorem kolumny.
                     }
        , ACTT_EDIT or ACTSC_INLINE or ACTR_CHECK  { ACTT_EDIT to kontrolka do edycji. Dziki ACTSC_INLINE nastpna
                                               kontrolka pojawi si w tej samej linijce...
                                               Dziki ACTR_CHECK zostaniemy powiadomieni o zmianach
                                               w tej kontrolce!
                                               }
        , '' + CFGTIP + 'Sprbuj wpisa "aa"!'  // Wszystko co jest po CFGTIP pjdzie do ToolTip'a!
        , CFG_EXAMPLE_VALUE // jako P1 w konfiguracji podajemy kolumn w tablicy CFG przypisan do
                          // do danej kontrolki. Podczas zapisywania, warto kontrolki zostanie
                          // zapisana w odpowiedniej kolumnie...  
        ,10,0  // Zrbmy mae wcicie...
        ,50  // Szeroko.
        ,0   // Wysokoci zajmie si automat...
        ); // Reszt parametrw moemy sobie darowa. Wszystkie i tak s rwne 0!
  { Moe swko komentarza? }
  UIActionAdd(IMIG_CFG_EXAMPLE , 0 , ACTT_COMMENT , '<- tutaj wpisuj!');
  { Zosta nam jeszcze button }
  UIActionAdd(IMIG_CFG_EXAMPLE , IMIA_CFG_EXAMPLE_BUTTON , ACTT_BUTTON , 'Kliknij mnie!',0,120,40);
  { Otwart grup koniecznie trzeba zamkn! }
  UIActionAdd(IMIG_CFG_EXAMPLE , 0 , ACTT_GROUPEND);


  Result := 1;
end;

function IStart():Integer;
begin
  { Tutaj wtyczk uruchamiamy. W tym wypadku Konnekt robi wszystko za nas :) }
  Result := 1;
end;

function IEnd(): Integer;
begin
  { Tutaj wtyczk wyczamy }
  Result := 1;
end;

const
  value: PChar = 'bb';

function ActionCfgProc(const anBase: sUIActionNotify_basePtr): Integer;
{  Tutaj obsugujemy akcje dla okna konfiguracji
   Sytuacja taka sama jak przy ActionProc  }
var
  an: sUIActionNotify_2paramsPtr;
begin
  an := sUIActionNotify_2paramsPtr(anBase);

  case (anBase.act.id and not IMIB_CFG) of
    CFG_EXAMPLE_VALUE:
    begin
       if (anBase.code = ACTN_CHECK) then
       begin
          { Sprawdzamy zawarto kontrolki. Jej aktualna warto znajduje si notify1 }
           if (StrComp(PChar(an.notify1), 'aa') = 0) then // sprawdzamy czy wpisalimy 'aa'
              an.notify1 := Integer(value); // jak tak - zmieniamy na bb
                   { Ze wzgldu na pewn "niedoskonao" ktr odkryem piszc ten
                      kod TRZEBA zmieni an->notify1 na inny bufor (ktry musi by
                      wany rwnie po opuszczeniu tej funkcji) eby zmieni warto kontrolki.
                      W nastpnej wersji programu bd bdzie poprawiony...
                      
                      ACTN_CHECK przysyany jest w tej chwili TYLKO do kontrolek z polem edycji...*/
               }

        end;
    end;
  end;

  Result := 0;
end;

function ActionProc(const anBase: sUIActionNotify_basePtr): Integer;
{ Tutaj obsugujemy akcje }
  {  Ponisza linijka suy TYLKO waszej wygodzie!
     Wikszo (o ile nie wszystkie) powiadomie przesyana jest jako sUIActionNotify_2params,
     korzystamy wtedy z obiektu an, w przeciwnym razie z anBase, lub castujemy do spodziewanego typu.
  }
var
  an: sUIActionNotify_2paramsPtr;
  sde: sDIALOG_enter;
  sdc: sDIALOG_choose;
  buff: array[0..200] of Char;
  t: array[0..4] of PChar;
  ok, desc: Boolean;
  ai: sUIActionInfo;
  sdl: sDIALOG_long;
  i,j: Integer;
  ret: PChar;
begin
  an := sUIActionNotify_2paramsPtr(anBase);

  if ((anBase.act.id and IMIB_) = IMIB_CFG) then
    Result := ActionCfgProc(anBase)
  else
    begin
      case (anBase.act.id) of
        IMIA_CFG_EXAMPLE_BUTTON:
          begin
            if ACTIONONLY(anBase) then   // Dziki temu obsuymy tu tylko ACTN_ACTION, czyli nacinicie buttona
            begin
              { Wywietlimy sobie okno dialogowe do wprowadzania tekstu }
              sde := sDialog_enterB();
              sde.info := 'Wpisz co chciaby ujrze w kontrolce edycji?';
              sde.title := 'actcfg.cpp';
              { jako warto pocztkow wemiemy to, co jest wpisane w pole edycji
                eby tego dokona musimy wywoa odpowiedni f-cj...
                Jak wida jej parametrem jest deskryptor akcji.
                Trzeba w nim poda identyfikator grupy i akcji o ktr nam chodzi...
              }
              UIActionCfgGetValue(sUIActionB(IMIG_CFG_EXAMPLE, IMIB_CFG or CFG_EXAMPLE_VALUE), buff,200);
              sde.value := buff;
              ICMessage(IMI_DLGENTER , Integer(@sde));
              { Wpisan warto wrzucamy do kontrolki }
              { Uwaga! Nacinicie w okienku na Cancel ustawia value na 0!!! }
              if sde.value <> nil then
                UIActionCfgSetValue(sUIActionB(IMIG_CFG_EXAMPLE, IMIB_CFG or CFG_EXAMPLE_VALUE), sde.value);
            end;
          end;
        IMIA_EXAMPLE_BUTTON:
          begin
            if ACTIONONLY(anBase) then
            begin
              { Pobierzemy sobie warto naszej kontrolki i j wywietlimy
                Najpierw jednak zapytamy uytkownika w jakim oknie chce zobaczy wynik... }
              sdc := sDIALOG_chooseB();
              sdc.def := 1;
              sdc.info := 'Wybierz jak przedstawi warto?';
              sdc.title := 'actcfg.cpp';
              sdc.items := 'IMI_INFORM'#10'IMI_ERROR'; { Kada linijka to nowy button }
              StrLCopy(buff, GETSTR(CFG_EXAMPLE_VALUE), 200); // Pobieramy warto
              case ICMessage(IMI_DLGBUTTONS , Integer(@sdc)) of
                1: Result := ICMessage(IMI_INFORM, Integer(@buff)); // Wybralimy opcj pierwsz
                2: Result := ICMessage(IMI_ERROR, Integer(@buff));
              else
               begin
                ret:= 'Nie to nie..';
                Result := ICMessage(IMI_INFORM, Integer(ret)); // Cancel
                end;
              end;
            end;
          end;
        IMIA_CNT_EXAMPLE:  // Akcja w menu kontaktw
          begin
            if anBase.code = ACTN_CREATE then
            begin
              {  Reagujemy na otworzenie menu. Moemy sprawdzi czy kontakt jest z jakiej sieci.
                  an to sUIActionNotify, czyli powiadomienie o zdarzeniu w akcji.
                  eby sprawdzi z jakim kontaktem powizana jest teraz akcja, trzeba sprawdzi
                  jej deskryptor, ktry znajduje si w an->act...
               }
              ok := GETCNTI(an.act.cnt, CNT_NET) = NET_NONE;
              ai := sUIActionInfoB(); // Zmienimy status kontrolki
              ai.act := an.act;  // Chodzi nam o t sam dla ktrej wywoane jest powiadomienie prawda?
              ai.mask := UIAIM_STATUS;  // Zmianiamy status
              if ok then
                ai.status := 0
              else
                ai.status := ACTS_HIDDEN;
              ai.statusMask := ACTS_HIDDEN; // Zmieniamy tylko ten jeden bit statusu
              if (ok) then  // eby byo mieszniej bdziemy zmienia jeszcze opis tekstowy...
              begin
                desc := False;
                ai.mask := ai.mask or UIAIM_TXT; // Zmieniamy jeszcze text
                if desc then
                  ai.txt := 'Ja chc nalee do sieeeeciiiii!'
                else
                  ai.txt := 'Jestem bez sieci i jestem z tego dumny!';    // wybieramy tekst...
                desc := not desc;
               end;
               ICMessage(IMI_ACTION_SET , Integer(@ai)); // Gotowe!
            end
            else
              begin
                sdl:= sDIALOG_longB();
                sdl.title := 'actcfg.cpp';
                sdl.info := 'Przyczanie do sieci...';
                t[0] := 'cz';
                t[1] := 'Przyczam';
                t[2] := 'zaczam';
                t[3] := 'rozczam';
                sdl.flag := DLONG_BLOCKING ;
                { UWAGA! Okazao si e w API jest bd, ktry przy Blokujcych dugich operacjach
                  objawia si tym, e w oknie z progresem bdzie nieodwieony prostokt...
                  Postaram si usun problem w nowszej wersji... :) }
                ICMessage(IMI_LONGSTART , Integer(@sdl)); // zaczynamy
                for i:=0 to 3 do
                begin
                  for j:=0 to 99 do
                    Sleep(10);
                         // Powtarzam operacj, poniewa proces odwieania okienka bdzie zrywa Sleep
                  sdl.progress := sdl.progress + 25;
                  sdl.info := t[i];
                  ICMessage(IMI_LONGSET , Integer(@sdl), DSET_PROGRESS or DSET_INFO);   // koczymy
                   
                end;
                for j:=0 to 49 do
                  Sleep(10);
                ICMessage(IMI_LONGEND , Integer(@sdl));   // koczymy
              end;
          end;
      end;
      Result := 0;
    end;
end;

function IMessageProc(const msgBase: sIMessage_basePtr): Integer; stdcall;
 { Tam gdzie nie uywasz parametrw, najbezpieczniej korzysta z msgBase }
    {Wikszo (o ile nie wszystkie) wiadomoci przesyana jest jako sIMessage_2params,
     korzystamy wtedy z obiektu msg, w przeciwnym razie z msgBase, lub castujemy do spodziewanego typu.
    }
var
  msg: sIMessage_2paramsPtr;
  ret: Integer;
  m: PChar;

begin
  msg := sIMessage_2paramsPtr(msgBase);
  ret := -1;

  case msgBase.id of
    { Wiadomoci na ktre TRZEBA odpowiedzie }
    IM_PLUG_NET: ret := NET_EXAMPLE;  // Zwracamy warto NET, ktra MUSI by rna od 0!
    IM_PLUG_TYPE: ret := IMT_UI or IMT_CONTACT or IMT_CONFIG;   // Zwracamy jakiego typu jest nasza wtyczka (ktre wiadomoci bdziemy obsugiwa)
    IM_PLUG_VERSION: ret := Integer(version); // Wersja wtyczki tekstowo major.minor.release.build ..., lub 0 jeeli wersja zapisana jest w zasobach DLLa
    IM_PLUG_SDKVERSION: ret := KONNEKT_SDK_V; // Ta linijka jest wymagana!
    IM_PLUG_SIG: ret :=  Integer(sig); // Sygnaturka wtyczki (krtka, kilkuliterowa nazwa)
    IM_PLUG_CORE_V: ret := Integer(core_v); // Wymagana wersja rdzenia
    IM_PLUG_UI_V: ret :=  0; // Wymagana wersja UI
    IM_PLUG_NAME: ret := Integer(name); // Pena nazwa wtyczki (ale najlepiej nie za duga!)
    IM_PLUG_NETNAME: ret := 0; // Nazwa obsugiwanej sieci (o ile jak sie obsuguje)
    IM_PLUG_INIT:
      begin
        Plug_Init(msg.p1, msg.p2);
        ret := Init();
      end;
    IM_PLUG_DEINIT:
      begin
        Plug_Deinit(msg.p1, msg.p2);
        ret := DeInit();
      end;

    IM_SETCOLS: ret:= ISetCols();

    IM_UI_PREPARE: ret := IPrepare();
    IM_START: ret := IStart();
    IM_END: ret := IEnd();

    IM_EX_TEST:
      begin
        m := 'ACTCFG @ IM_EX_TEST';
        ICMessage(IMI_NOTIFY , Integer(m));
        ret := 1;
      end;
    IM_UIACTION: ret := ActionProc(sUIActionNotify_basePtr(msg.p1));
  end;

  { Tutaj obsugujemy wszystkie pozostae komunikaty }
  { Z kadego komunikatu trzeba zwraca warto wiksz od 0. W przeciwnym razie,
    zostanie ustawiony bd i komunikat zostanie uznany za nie obsuony }


  if Assigned(Ctrl) and (ret < 0) then
  begin
    Ctrl.setError(IMERROR_NORESULT);
    ret := 0;
  end;

  Result := ret;
end;

exports
  IMessageProc;

begin
end.
