library Simple;
{  SIMPLE.DPR
   Przykadowa wtyczka dla programu Konnekt...

    -> Wykorzystanie kilku prostych komunikatw

   (c)2002 hao | Stamina
   (c)2005 Winthux
   http://www.konnekt.info
}

uses
  SysUtils,
  Plug in '..\..\api\plug.pas',
  PlugDefs in '..\..\api\plugdefs.pas',
  ui in '..\..\api\ui.pas';

{$R *.res}
const
  NET_EXAMPLE = 5;
  version: PChar = '0.0.0.1';
  name: PChar = 'Simple';
  sig: PChar = 'Ex1';

//---------------------------------------------------------------------------

function IStart(): Integer;
var
  UIHandle: Integer;
  msg: PChar;
begin
  { Tutaj wtyczk uruchamiamy }
  {eby odebra ten komunikat (IM_START) trzeba poda jako typ wtyczki
     IMT_UI.}
  IMLOG('HELLO!', [0]);  // Zapisujemy co do konnekt.log
  // Logujemy warto zwrcon przez IMC_PROFILEDIR
  // IMLOG przyjmuje ten sam format co funkcje z rodziny printf.
  IMLOG('IMC_PROFILE_DIR = %s' , [PChar(ICMessage(IMC_PROFILEDIR))]);
  // Logujemy warto zwrcon przez IMC_PLUG_COUNT
  IMLOG('IMC_PLUG_COUNT = %d' , [ICMessage(IMC_PLUG_COUNT)]);
  // Dla przykadu logujemy co z flag. Potem bdzie to mona odfiltrowa...
  IMDEBUG(DBG_FUNC, 'IStart()', [0]);
  // Pobieramy ID wtyczki interfejsu (zawsze na pozycji 0)
  UIHandle := ICMessage(IMC_PLUG_HANDLE , 0);
  // Logujemy nazw wtyczki UI. Pobieramy j wysyajc komunikat
  // bezporednio do wtyczki.
  {
    Ponisze nie dziaa, pewnie zmienio si cos w K od powstania tego przykladu
    Delphi natomiast nie jest tak sprytne jak c i rzuca wyjtkiem zamiast wydrukowac
    null lub 0 ;)
  IMLOG('UI = "%s"' , [PChar(IMessageDirect(IM_PLUG_NAME , UIHandle))]);
  }
  // Wywietlamy komunikat w zalenoci od stanu poczenia...
  if ICMessage(IMC_CONNECTED) <> 0 then
  begin
      // Wysyamy komunikat z net i type = 0 (to samo co ICMessage)
      // Wiadomo dotrze do UI
      // Pojawi si okno informujce
      IMessage(IMI_INFORM , 0 , 0 , Integer(PChar('Jestemy poczeni z inernetem!')));
  end
  else
  begin
      // Pojawi si okno bdu
      IMessage(IMI_ERROR , 0 , 0 , Integer(PChar('Nie wykryem poczenia!')));
  end;
  IMessage(IMI_INFORM , 0 , 0 , Integer(PChar('Zajrzyj do Konnekt.log - zobaczysz wygenerowane t wtyczk linijki!')));
  Result := 1;
end;

function IMessageProc(const msgBase: sIMessage_basePtr): Integer; stdcall;
 { Tam gdzie nie uywasz parametrw, najbezpieczniej korzysta z msgBase }
    {Wikszo (o ile nie wszystkie) wiadomoci przesyana jest jako sIMessage_2params,
     korzystamy wtedy z obiektu msg, w przeciwnym razie z msgBase, lub castujemy do spodziewanego typu.
    }
var
  msg: sIMessage_2paramsPtr;
  ret: Integer;

begin
  msg := sIMessage_2paramsPtr(msgBase);
  ret := -1;

  case msgBase.id of
    { Wiadomoci na ktre TRZEBA odpowiedzie }
    IM_PLUG_NET: ret := NET_EXAMPLE;  // Zwracamy warto NET, ktra MUSI by rna od 0!
    IM_PLUG_TYPE: ret := IMT_UI;   // Zwracamy jakiego typu jest nasza wtyczka (ktre wiadomoci bdziemy obsugiwa)
    IM_PLUG_VERSION: ret := Integer(version); // Wersja wtyczki tekstowo major.minor.release.build ..., lub 0 jeeli wersja zapisana jest w zasobach DLLa
    IM_PLUG_SDKVERSION: ret := KONNEKT_SDK_V; // Ta linijka jest wymagana!
    IM_PLUG_SIG: ret :=  Integer(sig); // Sygnaturka wtyczki (krtka, kilkuliterowa nazwa)
    IM_PLUG_NAME: ret := Integer(name); // Pena nazwa wtyczki (ale najlepiej nie za duga!)
    IM_PLUG_NETNAME: ret := 0; // Nazwa obsugiwanej sieci (o ile jak sie obsuguje)
    IM_PLUG_INIT:
      begin
        Plug_Init(msg.p1, msg.p2);
        ret := 1;
      end;
    IM_PLUG_DEINIT:
      begin
        Plug_Deinit(msg.p1, msg.p2);
        ret := 1;
      end;

    IM_START: ret := IStart();

  end;

  { Tutaj obsugujemy wszystkie pozostae komunikaty }
  { Z kadego komunikatu trzeba zwraca warto wiksz od 0. W przeciwnym razie,
    zostanie ustawiony bd i komunikat zostanie uznany za nie obsuony }


  if Assigned(Ctrl) and (ret < 0) then
  begin
    Ctrl.setError(IMERROR_NORESULT);
    ret := 0;
  end;

  Result := ret;
end;

exports
  IMessageProc;

begin
end.
 